import bank.Bank;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import player.Player;
import strategy.StrategyRepository;

public class StarterAgent extends Agent {
  /** Creates new StarterAgent */
  public StarterAgent() {
    super();
  }

  protected void setup() {
    System.out.println(getLocalName() + " setting up");
    // create the agent descrption of itself
    DFAgentDescription dfd = new DFAgentDescription();
    dfd.setName(getAID());
    try {
      DFService.register(this, dfd);
    } catch (FIPAException e) {
      System.err.println(getLocalName() + ": registration with DF failed. Killing myself.");
      doDelete();
    }
    // create Agents
    (new Bank()).doStart("Bank");
    (new StrategyRepository()).doStart("StrategieVerw");
    doWait(5000);
    (new wuerfeln.GameHost()).doStart("Wuerfeln");
    doWait(1000);
    (new meiern.GameHost()).doStart("Meiern1");
    doWait(1000);
    (new meiern.GameHost()).doStart("Meiern2");
    doWait(1000);
    (new viergewinnt.C4GameHost()).doStart("Vier gewinnt");
    doWait(5000);


    startAgents(14);
    doDelete();
  }

  private void startAgents(int nPlayer) {
    try {
      for (int i = 0; i < nPlayer; i++) {
        // create a new agent
        Agent player = new Player();
        player.doStart("Player_" + i);
      }
    } catch (Exception e) {
      System.err.println("Exception while creating Player: " + e);
      e.printStackTrace();
    }
  }
}
