package bank;

import bank.onto.BankingOntology;
import jade.content.lang.sl.SLCodec;
import jade.core.AID;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import java.util.Iterator;
import java.util.Vector;

/* Generated by Together */

public class Bank extends Agent {
  private Account getAccount(AID owner) {
    Account account = null;
    Account help = null;
    Iterator iterator = accounts.iterator();
    while (iterator.hasNext() && account == null) {
      help = (Account)iterator.next();
      if (help.getOwner().equals(owner)) account = help;
    }
    return account;
  }

  public void addAccount(AID owner) {
    if (getAccount(owner) == null) {
      accounts.add(new Account(owner));
      window.newRow(owner.getLocalName(), START_CREDITS);
    }
  }

  public void credit(AID owner, int amount) {
    Account account = getAccount(owner);
    if (account != null) {
      account.credit(amount);
      window.setCredits(owner.getLocalName(), getBalance(owner));
    }
  }

  public void debit(AID owner, int amount) {
    Account account = getAccount(owner);
    if (account != null) {
      account.debit(amount);
      window.setCredits(owner.getLocalName(), getBalance(owner));
    }
  }

  public int getBalance(AID owner) {
    Account account = getAccount(owner);
    if (account != null) return account.getBalance(); else
      return Integer.MIN_VALUE;
  }

  protected void setup() {
    getContentManager().registerLanguage(new SLCodec());
    getContentManager().registerOntology(BankingOntology.getInstance());
    DFAgentDescription dfad = new DFAgentDescription();
    ServiceDescription sd = new ServiceDescription();
    sd.setName(getName());
    sd.addOntology(BankingOntology.ONTOLOGY_NAME);
    sd.setType("BANK");
    dfad.setName(getAID());
    dfad.addServices(sd);
    dfad.addOntology(BankingOntology.ONTOLOGY_NAME);
    // Registrierung senden
    try {
      DFService.register(this, dfad);
    } catch (FIPAException e) {
      System.err.println(getLocalName() + ": registration with DF failed.");
      doDelete();
    }
    addBehaviour(new ReceiveOrders(this));
  }

  private Vector accounts = new Vector();
  public static final int START_CREDITS = 30;
  private BankWindow window = new BankWindow();
}
