/* Generated by Together */

package bank;

import bank.onto.BankingOntology;
import bank.onto.CreateAccount;
import bank.onto.Credit;
import bank.onto.Debit;
import bank.onto.GetBalance;
import jade.content.Concept;
import jade.content.onto.basic.Action;
import jade.core.behaviours.CyclicBehaviour;
import jade.domain.FIPANames;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

public class ReceiveOrders extends CyclicBehaviour {
  private MessageTemplate mt;
  private ACLMessage rec;

  public ReceiveOrders(Bank bank) {
    super(bank);
    mt = MessageTemplate.and(MessageTemplate.MatchPerformative(ACLMessage.REQUEST),
        MessageTemplate.and(MessageTemplate.MatchLanguage(FIPANames.ContentLanguage.FIPA_SL),
        MessageTemplate.MatchOntology(BankingOntology.ONTOLOGY_NAME)));
  }

  public void action() {
    rec = myAgent.receive(mt);
    if (rec == null) block(2000); else {
      try {
        Concept cp = ((Action)myAgent.getContentManager().extractContent(rec)).getAction();
        if (cp instanceof CreateAccount) ((Bank)myAgent).addAccount(((CreateAccount)cp).getOwner());
        else if (cp instanceof Credit) {
          Credit cr = (Credit)cp;
          ((Bank)myAgent).credit(cr.getOwner(), cr.getAmount());
        } else if (cp instanceof Debit) {
          Debit cr = (Debit)cp;
          ((Bank)myAgent).debit(cr.getOwner(), cr.getAmount());
        } else if (cp instanceof GetBalance) {
          ACLMessage rep = rec.createReply();
          rep.setPerformative(ACLMessage.AGREE);
          myAgent.send(rep);
          rep.setPerformative(ACLMessage.INFORM);
          rep.setContent(String.valueOf(((Bank)myAgent).getBalance(((GetBalance)cp).getOwner())));
          myAgent.send(rep);
        }
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
  }
}
