package gamehost;

import jade.core.behaviours.*;
import jade.domain.*;
import java.util.Vector;
import jade.lang.acl.ACLMessage;
import jade.core.*;


class RemovePlayer extends OneShotBehaviour{

    private AbsGameHost gameHost;

    public RemovePlayer(AbsGameHost host){
        super(host);
        gameHost = host;
    }

    /**
     * Runs the behaviour. This abstract method must be implemented by
     * <code>Behaviour</code>subclasses to perform ordinary behaviour
     * duty. An agent schedules its behaviours calling their
     * <code>action()</code> method; since all the behaviours belonging
     * to the same agent are scheduled cooperatively, this method
     * <b>must not</b> enter in an endless loop and should return as
     * soon as possible to preserve agent responsiveness. To split a
     * long and slow task into smaller section, recursive behaviour
     * aggregation may be used.
     * @see <{CompositeBehaviour}>
     */
    public void action() {
        Vector players = gameHost.getPlayers();
        //System.out.println("Es sind noch " + numPlayers + " Spieler da.");
        ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
        msg.setSender(gameHost.getAID());
        AID winner = gameHost.getWinner();
        if (winner != null) {
            msg.setContent("Won");
            gameHost.sendPrize(winner);
            msg.addReceiver(winner);
            myAgent.send(msg);
            players.removeElement(winner);
            msg.removeReceiver(winner);
        }
        int numPlayers = players.size();
        msg.setContent("Lost");
        for (int i = 0; i < numPlayers; i++) msg.addReceiver((AID) players.elementAt(i));
        myAgent.send(msg);
        gameHost.finishGame();
        gameHost.resetGame();
        if (gameHost.maxGamesPlayed()) myAgent.doDelete();
    }

    /*public int onEnd(){
        if (!myAgent.maxGamesPlayed()) return GameHost.MORE_GAMES;
        else return GameHost.NO_MORE_GAMES;
    }*/

}