package meiern;

import gamehost.AbsGameHost;
import jade.core.AID;
import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import java.util.Random;

class EvaluateMove extends OneShotBehaviour {
  private meiern.GameHost gameHost;
  private int exitCode;
  private Random rnd = new Random();

  public EvaluateMove(meiern.GameHost a) {
    super(a);
    gameHost = a;
  }

  public void action() {
    AID currentPlayer = gameHost.getCurrentPlayer();
    AID lastPlayer = gameHost.getLastPlayer();
    int lastRealDice = gameHost.getLastRealDice();
    int lastBluffDice;
    int lastlastDice;
    if (lastRealDice != GameHost.FIRST_TURN) {
      lastBluffDice = gameHost.getLastBluffDice();
      lastlastDice = gameHost.getLastLastDice();
      gameHost.println(currentPlayer.getLocalName() + ": Bitte wrfeln oder aufdecken! " + lastPlayer.getLocalName() +
          " sagt, er hat " + gameHost.getDiceOfIndex(lastBluffDice) + " gewrfelt.");
    } else {
      lastBluffDice = -1;
      lastlastDice = 0;
      gameHost.println("Neue Runde! " + currentPlayer.getLocalName() + ": Bitte wuerfeln!");
    }
    // ***** Zugaufforderung an nchsten Spieler senden *****
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(currentPlayer);
    msg.setContent("YourTurn");
    // msg.setLanguage("welcheLanguage");
    // msg.setOntology("welcheOntology");
    myAgent.send(msg);
    // HIER MSSTE MAN AM BESTEN NOCH EINE "OK"-NACHRICHT VON SENDMOVE ALS BESTTIGUNG EINFGEN
    msg.setContent(Integer.toString(lastBluffDice)); // an dieser Stelle Konvertierung des Integer-Wert in String
    myAgent.send(msg);
    // ***** Zug vom Spieler empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    MessageTemplate m2 = MessageTemplate.MatchSender(currentPlayer);
    MessageTemplate m3 = MessageTemplate.and(m1, m2);
    // blockingReceive: es wird beliebig lang auf eine spezifische Nachricht gewartet
    ACLMessage turn = myAgent.blockingReceive(m3);
    // ***** Auswertung der Zuganweisung *****
    // erwartet wird vom Player entweder "Wuerfeln" oder "Zweifeln"
    if (turn.getContent().equalsIgnoreCase("Zweifeln"))
    // ein Player hat hoffentlich keine "Zweifel", wenn er der erste Spieler ist ;o)
    {
      boolean hatGeblufft = (lastRealDice <= lastlastDice);
      // bertrifft das reelle Ergebnis das vorherige Ergebnis ??
      gameHost.print(currentPlayer.getLocalName() + " zweifelt...");
      if (hatGeblufft) {
        // der vorherige Spieler hat geblufft und somit verloren
        // Im GameHost wird ihm deshalb ein Punkt abgezogen und
        // er ist der Startspieler der nchsten Runde
        gameHost.println(" und hat Recht. " + lastPlayer.getLocalName() +
            " hat gelogen. Dafr verliert er jetzt einen Punkt.");
        gameHost.incrementPlayerZaehler(lastPlayer);
      } else {
        // der Spieler wollte sehen, aber der vorherige Spieler
        // hatte einen ausreichenden Wert gewrfelt
        // Somit hat der jetzige Spieler verloren.
        // Im GameHost wird ihm deshalb ein Punkt abgezogen und
        // er ist der Startspieler der nchsten Runde
        gameHost.println(" und liegt falsch. Dafr verliert er jetzt einen Punkt.");
        gameHost.incrementPlayerZaehler(currentPlayer);
      }
      gameHost.printPoints();
      //jetzt wird es kritisch... er werden Punkte abgezogen und es scheiden vielleicht spieler aus...
      if (gameHost.getPlayers().size() == 1) {
        //wer ist der Gewinner?
        AID winner = (AID)gameHost.getPlayers().elementAt(0);
        //ein bischen angeben...
        gameHost.println(winner.getLocalName() + " hat gewonnen!");
        gameHost.setWinner(winner);
        //und leider das Spiel beenden...
        exitCode = AbsGameHost.GAME_OVER;
      } else {
        exitCode = AbsGameHost.GAME_NOT_OVER;
      }
    } else {
      if (turn.getContent().equalsIgnoreCase("Wuerfeln")) {
        // auf Index wrfeln
        int zufallszahl1 = rnd.nextInt(6) + 1;
        int zufallszahl2 = rnd.nextInt(6) + 1;
        if (zufallszahl1 < zufallszahl2) {
          int temp = zufallszahl1;
          zufallszahl1 = zufallszahl2;
          zufallszahl2 = temp;
        }
        int zufallszahl = gameHost.getIndexOfDice(zufallszahl1 * 10 + zufallszahl2);
        if (lastRealDice == GameHost.FIRST_TURN)
          gameHost.println(currentPlayer.getLocalName() + " will wrfeln."); else
          gameHost.println(currentPlayer.getLocalName() + " glaubt " + lastPlayer.getLocalName() +
              " noch mal so eben und will selbst wrfeln.");
        gameHost.println("Fr " + currentPlayer.getLocalName() + " wurde gewrfelt: " + gameHost.getDiceOfIndex(zufallszahl));
        msg.setContent(String.valueOf(zufallszahl));
        myAgent.send(msg);
        // neues blockingReceive, gewartet wird auf Nachricht vom gleich Player
        ACLMessage bluff = myAgent.blockingReceive(m3);
        // Content der Nachricht sollte eine Indexzahl (Integer) sein
        int bluffErgebnis = Integer.parseInt(bluff.getContent());
        if (bluffErgebnis != zufallszahl)
          gameHost.println(currentPlayer.getLocalName() + " blufft: " +
              gameHost.getDiceOfIndex(bluffErgebnis) + " sagt er an!");
        if (bluffErgebnis == zufallszahl)
          gameHost.println(currentPlayer.getLocalName() + " ist ehrlich: " +
              gameHost.getDiceOfIndex(bluffErgebnis) + " sagt er an!");
        // Setzen des neuen reellen und des gesagten Wrfel-Wertes (fr nchsten Spieler)
        gameHost.setLastLastDice(lastBluffDice);
        gameHost.setLastRealDice(zufallszahl);
        gameHost.setLastBluffDice(bluffErgebnis);
        gameHost.setLastPlayer(currentPlayer);
        // keiner hat verloren...
        gameHost.incrementPlayerZaehler(null);
        exitCode = AbsGameHost.GAME_NOT_OVER;
      }
    }
  }

  public int onEnd() {
    return exitCode;
  }
}
