package meiern;

import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import java.util.Random;
import player.CheckCredits;
import player.Player;

class SendMoveBis62 extends OneShotBehaviour {
  //hier steht der inhalt der Nachricht nach einem empfangen()
  String msgcontent;
  //WrfelIndex vom Vorgnger
  int wuerfelIndexV;
  //WrfelIndex von Mir
  int wuerfelIndexM;
  int zustand;
  private Random rnd = new Random();
  final int MY_TURN = 1;
  final int WON = 2;
  final int LOST = 3;
  final int UNKNOWN = 4;

  public SendMoveBis62(Player a) { super(a); }

  public void action() {
    zustand = zustandsWechsel();
    // solange nicht GameOver anweisungen durchlaufen
    while ((zustand != WON) && (zustand != LOST)) {
      switch (zustand) {
        //ist mein zug?
        case MY_TURN: {
            //Glauben und Wrfeln oder Bluffen und sehen wollen
            if (glauben(wuerfelIndexV)) {
              //ich will wrfeln
              wuerfelnSenden();
              //was habe ich gewrfelt?
              empfangen();
              wuerfelIndexM = Integer.parseInt(msgcontent);
              //jetzt muss ich mir berlegen was ich versende... und dann versende ich es auch
              this.gesagtesSenden(this.welchenIndexSagen(wuerfelIndexM));
            } else {
              zweifelnSenden();
              //runde soll
            }
            break;
          }
        case UNKNOWN: {
            //da der Zustand unbekannt ist... einfach auf andere Nachricht warten
            break;
          }
      }
      zustand = zustandsWechsel();
    }
    if (zustand == WON) ((Player)myAgent).sendWon(); else if (zustand == LOST) ((Player)myAgent).sendLost();
    myAgent.addBehaviour(new CheckCredits(myAgent));
  }

  private void empfangen() {
    // ***** Nachricht vom GameHost empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    // MessageTemplate m2 = MessageTemplate.MatchContent("YourTurn");
    MessageTemplate m3 = MessageTemplate.MatchSender(((Player)myAgent).getHost());
    MessageTemplate m5 = MessageTemplate.and(m1, m3);
    // receive: Warten auf Nachricht von GameHost
    ACLMessage msg = myAgent.blockingReceive(m5);
    // ***** Nachricht auswerten *****
    // hier einfach, da einfaches Wrfelspiel
    msgcontent = msg.getContent();
  }

  private int zustandsWechsel() {
    int zst;
    empfangen();
    if (msgcontent.equalsIgnoreCase("YourTurn")) {
      //da ich dran bin muss ich auf das Ergeniss des Vorgngers warten
      empfangen();
      //wrfelergebniss aus der Nachricht extrahieren
      wuerfelIndexV = Integer.parseInt(msgcontent);
      //jetzt muss ich mir meinen Zug berlegen...
      zst = MY_TURN;
    } else if (msgcontent.equalsIgnoreCase("Won")) zst = WON; else if (msgcontent.equalsIgnoreCase("Lost")) zst = LOST; else
      zst = UNKNOWN;
    return zst;
  }

  private void wuerfelnSenden() {
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getHost());
    msg.setContent("Wuerfeln");
    // Nachricht senden
    myAgent.send(msg);
    if (wuerfelIndexV != -1) {
      //System.out.println(myAgent.getLocalName() + ": Ich glaube es noch mal... und will wrfeln.");
    } else {
      //System.out.println(myAgent.getLocalName() + ": Eine neue Runde... ich will wrfeln.");
    }
  }

  private void zweifelnSenden() {
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getHost());
    msg.setContent("Zweifeln");
    // Nachricht senden
    myAgent.send(msg);
    //System.out.println(myAgent.getLocalName() + ": Das glaube ich nicht. Ich will sehen.");
  }

  private void gesagtesSenden(int gesagterIndex) {
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getHost());
    msg.setContent(String.valueOf(gesagterIndex));
    // Nachricht senden
    myAgent.send(msg);
    //System.out.println(myAgent.getLocalName() + ": hhhmmmm... Ich habe " + MeiernGameHost.getDiceOfIndex(gesagterIndex) + ".");
  }

  /** Methode fhrt intern einen zufallstest durch ob die Wuerfel des Vorgngers geglaubt werden oder angezweifelt. */
  private boolean glauben(int indexWuerfel) {
    //wir sind schon pessimistisch ;)
    boolean glauben = false;
    //int zwischen 0..20
    if (indexWuerfel < 12) {
      glauben = true;
    }
    //soll der Zug geglaubt werden?
    return glauben;
  }

  /** Methode entscheidet abhngig davon was gewuerfelt wurde was gesagt werden soll */
  private int welchenIndexSagen(int gewuerfelterIndex) {
    int wasGesagtWird;
    if (gewuerfelterIndex > wuerfelIndexV) {
      //Ergebniss ist grer... muss nicht lgen also sage ich die Wahrheit.
      wasGesagtWird = gewuerfelterIndex;
    } else {
      //mist Ergeniss ist gleich oder kleiner... jetzt wirds ernst ich muss lgen wenn ich kann.
      //erstmal einfach ein index weiter als Vorgnger...
      wasGesagtWird = wuerfelIndexV + 1;
    }
    return wasGesagtWird;
  }
}
