package player;

import bank.onto.BankingOntology;
import bank.onto.GetBalance;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.FIPANames;
import jade.lang.acl.ACLMessage;
import jade.proto.AchieveREInitiator;
import java.util.Random;

/**
 * @author  Christian Birmes
 * @version
 */
public class CheckCredits extends SimpleBehaviour {
  private int exitCode;
  private int state = 0;
  private int credits;
  private AchieveREInitiator init;
  private boolean finished = false;

  /** Creates new MoreGameHosts */
  public CheckCredits(Agent a) {
    super(a);
  }

  public void action() {
    switch (state) {
      case 0: {
          //System.out.println(myAgent.getLocalName() + " ist im MoreGameHosts-Verhalten");
          exitCode = Player.MORE_GAME_HOSTS;
          ((Player)myAgent).setHost(null);
          ((Player)myAgent).setStrategy(null);
          ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
          msg.setLanguage(FIPANames.ContentLanguage.FIPA_SL);
          msg.setOntology(BankingOntology.ONTOLOGY_NAME);
          msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
          msg.setSender(myAgent.getAID());
          msg.addReceiver(((Player)myAgent).getBank());
          GetBalance gb = new GetBalance();
          gb.setOwner(myAgent.getAID());
          Action action = new Action();
          action.setActor(((Player)myAgent).getBank());
          action.setAction(gb);
          try {
            myAgent.getContentManager().fillContent(msg, action);
          } catch (Exception e) {
            e.printStackTrace();
          }
          init = new AchieveREInitiator(myAgent, msg) {
            protected void handleInform(ACLMessage response) {
              credits = Integer.parseInt(response.getContent());
            }
          };
          myAgent.addBehaviour(init);
          state = 1;
        }
      case 1: {
          if (init.done()) {
            if (credits > 0) {
              ((Player)myAgent).setCurrentHostNo((new Random()).nextInt(((Player)myAgent).getHosts().length));
              myAgent.addBehaviour(new RegisterWithGameHost((Player)myAgent));
              //if (credits < Bank.START_CREDITS / 5) ((Player) myAgent).setSelectionStrategy(Player.BEST);
            } else {
              exitCode = Player.NO_MORE_GAME_HOSTS;
              myAgent.addBehaviour(new Suicide(myAgent));
            }
            finished = true;
          } else
            block(1000);
        }
    }
  }

  //public int onEnd() {return exitCode;}
  public boolean done() {
    return finished;
  }
}
