package player;

import jade.content.ContentElement;
import jade.content.onto.basic.Action;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.FIPANames;
import jade.lang.acl.ACLMessage;
import jade.proto.AchieveREInitiator;
import jade.util.leap.ArrayList;
import java.util.Random;
import strategy.Strategy;
import strategy.onto.GamingOntology;
import strategy.onto.GetStrategies;
import strategy.onto.GetStrategy;
import strategy.onto.Strategies;
import strategy.onto.StrategyDescription;

/* Generated by Together */

public class GetRandomStrategy extends SimpleBehaviour {
  private GetAllStrategies gas;
  private boolean finished = false;
  private int state = 0;

  public GetRandomStrategy(Player player) {
    super(player);
  }

  public void action() {
    switch (state) {
      case 0: {
          startInitiator();
          state = 1;
        }
      case 1: {
          if (gas.done()) finished = true; else
            block(1000);
        }
    }
  }

  public boolean done() {
    return finished;
  }

  private void startInitiator() {
    ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
    msg.setLanguage(FIPANames.ContentLanguage.FIPA_SL);
    msg.setOntology(GamingOntology.ONTOLOGY_NAME);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getRepository());
    msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
    GetStrategies gs = new GetStrategies();
    gs.setGame(((Player)myAgent).getGame());
    Action action = new Action();
    action.setActor(((Player)myAgent).getRepository());
    action.setAction(gs);
    try {
      myAgent.getContentManager().fillContent(msg, action);
    } catch (Exception e) {
      e.printStackTrace();
    }
    gas = new GetAllStrategies((Player)myAgent, msg);
    gas.registerHandleInform(new PickStrategy((Player)myAgent, gas.REPLY_KEY));
    myAgent.addBehaviour(gas);
  }

  class GetAllStrategies extends AchieveREInitiator {
    public GetAllStrategies(Player player, ACLMessage msg) {
      super(player, msg);
    }

    protected void handleFailure(ACLMessage msg) {
      // noch implementieren!
    }

    protected void handleNotUnderstood(ACLMessage msg) {
      // noch implementieren!
    }

    protected void handleRefuse(ACLMessage msg) {
      // noch implementieren!
    }
  }


  class PickStrategy extends SimpleBehaviour {
    private String replyKey;
    private int state = 0;
    private GetTheStrategy gts;
    private boolean finished = false;

    public PickStrategy(Player player, String replyKey) {
      super(player);
      this.replyKey = replyKey;
    }

    public void action() {
      switch (state) {
        case 0: {
            pick();
            state = 1;
          }
        case 1: {
            if (gts.done()) finished = true; else
              block(1000);
          }
      }
    }

    public boolean done() {
      return finished;
    }

    private void pick() {
      ACLMessage reply = (ACLMessage)getDataStore().get(replyKey);
      ContentElement ce = null;
      try {
        ce = myAgent.getContentManager().extractContent(reply);
      } catch (Exception e) {
        e.printStackTrace();
      }
      if (ce instanceof Strategies) {
        ArrayList al = (ArrayList)((Strategies)ce).getStrategies();
        StrategyDescription sd = (StrategyDescription)al.get((new Random()).nextInt(al.size()));
        ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
        msg.setLanguage(FIPANames.ContentLanguage.FIPA_SL);
        msg.setOntology(GamingOntology.ONTOLOGY_NAME);
        msg.setSender(myAgent.getAID());
        msg.addReceiver(((Player)myAgent).getRepository());
        msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
        GetStrategy gs = new GetStrategy();
        gs.setStrategy(sd);
        Action action = new Action();
        action.setActor(((Player)myAgent).getRepository());
        action.setAction(gs);
        try {
          myAgent.getContentManager().fillContent(msg, action);
        } catch (Exception e) {
          e.printStackTrace();
        }
        gts = new GetTheStrategy((Player)myAgent, msg);
        myAgent.addBehaviour(gts);
      }
    }

    class GetTheStrategy extends AchieveREInitiator {
      public GetTheStrategy(Player player, ACLMessage msg) {
        super(player, msg);
      }

      protected void handleFailure(ACLMessage msg) {
        // noch implementieren!
      }

      protected void handleInform(ACLMessage msg) {
        try {
          ((Player)myAgent).setStrategy((Strategy)msg.getContentObject());
        } catch (Exception e) {
          e.printStackTrace();
        }
      }

      protected void handleNotUnderstood(ACLMessage msg) {
        // noch implementieren!
      }

      protected void handleRefuse(ACLMessage msg) {
        // noch implementieren!
      }
    }
  }
}
