package player;

import jade.content.onto.basic.Action;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.SimpleBehaviour;
import jade.domain.FIPANames;
import jade.lang.acl.ACLMessage;
import strategy.onto.GamingOntology;
import strategy.onto.GetMostSuccessfullStrategy;

/* Generated by Together */

public class SelectStrategy extends SimpleBehaviour {
  private Player player;
  private int state = 0;
  private boolean finished = false;
  private Behaviour behaviour;

  public SelectStrategy(Player player) {
    super(player);
    this.player = player;
  }

  public boolean done() {
    return finished;
  }

  public void action() {
    switch (state) {
      case 0: {
          switch (player.getSelectionStrategy()) {
            case Player.RANDOM:
              behaviour = new GetRandomStrategy(player);
              break;
            case Player.BEST:
              best();
              break;
              //case RISK : behaviour = new GetRiskStrategy(player);
          }
          myAgent.addBehaviour(behaviour);
          state = 1;
        }
      case 1: {
          if (behaviour.done()) finished = true; else
            block(1000);
        }
    }
  }

  private void best() {
    ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
    msg.setLanguage(FIPANames.ContentLanguage.FIPA_SL);
    msg.setOntology(GamingOntology.ONTOLOGY_NAME);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(player.getRepository());
    msg.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
    GetMostSuccessfullStrategy gmss = new GetMostSuccessfullStrategy();
    gmss.setGame(player.getGame());
    Action action = new Action();
    action.setActor(player.getRepository());
    action.setAction(gmss);
    try {
      myAgent.getContentManager().fillContent(msg, action);
    } catch (Exception e) {
      e.printStackTrace();
    }
    behaviour = new GetBestStrategy(player, msg);
  }
}
