package strategy;

import jade.content.ContentElement;
import jade.core.behaviours.CyclicBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import strategy.onto.GamingOntology;
import strategy.onto.Lost;
import strategy.onto.Won;

/* Generated by Together */

public class HandleInforms extends CyclicBehaviour {
  private StrategyRepository sr;
  private MessageTemplate mt;

  public HandleInforms(StrategyRepository sr) {
    super(sr);
    this.sr = sr;
    mt = MessageTemplate.and(MessageTemplate.MatchOntology(GamingOntology.ONTOLOGY_NAME),
        MessageTemplate.MatchPerformative(ACLMessage.INFORM));
  }

  public void action() {
    ACLMessage msg = myAgent.receive(mt);
    if (msg != null) {
      ContentElement ce = null;
      try {
        ce = myAgent.getContentManager().extractContent(msg);
        if (ce instanceof Won)
          sr.addWin(((Won)ce).getStrategy()); else if (ce instanceof Lost)
          sr.addLoss(((Lost)ce).getStrategy());
      } catch (Exception e1) {
        //e1.printStackTrace();
        try {
          sr.addStrategy((Strategy)msg.getContentObject());
        } catch (Exception e2) {
          e2.printStackTrace();
        }
      }
    } else
      block();
  }
}
