/*
 * RepositoryWindow.java
 *
 * Created on 7. Juli 2002, 02:21
 */

package strategy;

import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/** @author  Christian Birmes */
public class RepositoryWindow extends JFrame {
  /** Creates new form RepositoryWindow */
  public RepositoryWindow() {
    initComponents();
    show();
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
   */
  private void initComponents() { //GEN-BEGIN:initComponents
    scrollPane = new JScrollPane();
    table = new JTable();
    setTitle("Strategie-Verwaltung");
    addWindowListener(
        new WindowAdapter() {
          public void windowClosing(WindowEvent evt) {
            exitForm(evt);
          }
        });
    table.setModel(new DefaultTableModel(
        new Object[] [] { { null, null, null, null, null, null, null }, { null, null, null, null, null, null, null }, {
            null, null, null, null, null, null, null
          }, { null, null, null, null, null, null, null }, { null, null, null, null, null, null, null }, {
            null, null, null, null, null, null, null
          }, { null, null, null, null, null, null, null }, { null, null, null, null, null, null, null }, {
            null, null, null, null, null, null, null
          }, { null, null, null, null, null, null, null }
        },
        new String[] {
          "Spiel", "Name", "Risiko", "Gewinne", "Verluste", "Abrufe", "Gewinnquote"
        }) {
          Class[] types = new Class[] {
            String.class, String.class, Integer.class, Integer.class, Integer.class, Integer.class, Float.class
          };
          public Class getColumnClass(int columnIndex) {
            return types[columnIndex];
          }
        });
    scrollPane.setViewportView(table);
    getContentPane().add(scrollPane, BorderLayout.CENTER);
    pack();
  } //GEN-END:initComponents

  /** Exit the Application */
  private void exitForm(WindowEvent evt) { //GEN-FIRST:event_exitForm
    //System.exit(0);
  } //GEN-LAST:event_exitForm

  public void newRow(String game, String name, int risk, int wins, int losses) {
    int row = -1;
    int i;
    for (i = 0; ((i < table.getRowCount()) && (row == -1)); i++) {
      if (table.getValueAt(i, 0) == null) row = i;
    }
    table.setValueAt(game, row, 0);
    table.setValueAt(name, row, 1);
    table.setValueAt(new Integer(risk), row, 2);
    table.setValueAt(new Integer(wins), row, 3);
    table.setValueAt(new Integer(losses), row, 4);
    table.setValueAt(new Integer(0), row, 5);
    table.setValueAt(new Float(0.0), row, 6);
  }

  public void setWins(String game, String name, int number) {
    int row = -1;
    int i;
    for (i = 0; ((i < table.getRowCount()) && (row == -1)); i++) {
      if ((((String)table.getValueAt(i, 0)).equalsIgnoreCase(game)) &&
          (((String)table.getValueAt(i, 1)).equalsIgnoreCase(name)))row = i;
    }
    table.setValueAt(new Integer(number), row, 3);
    int sum = number + ((Integer)table.getValueAt(row, 4)).intValue();
    float ratio = 0.0f;
    if (sum > 0) ratio = (float)number / (float)sum;
    table.setValueAt(new Float(ratio), row, 6);
  }

  public void setLosses(String game, String name, int number) {
    int row = -1;
    int i;
    for (i = 0; ((i < table.getRowCount()) && (row == -1)); i++) {
      if ((((String)table.getValueAt(i, 0)).equalsIgnoreCase(game)) &&
          (((String)table.getValueAt(i, 1)).equalsIgnoreCase(name)))row = i;
    }
    table.setValueAt(new Integer(number), row, 4);
    int sum = number + ((Integer)table.getValueAt(row, 3)).intValue();
    float ratio = 0.0f;
    if (sum > 0) ratio = (float)((Integer)table.getValueAt(row, 3)).intValue() / (float)sum;
    table.setValueAt(new Float(ratio), row, 6);
  }

  public void addUse(String game, String name) {
    int row = -1;
    int i;
    for (i = 0; ((i < table.getRowCount()) && (row == -1)); i++) {
      if ((((String)table.getValueAt(i, 0)).equalsIgnoreCase(game)) &&
          (((String)table.getValueAt(i, 1)).equalsIgnoreCase(name)))row = i;
    }
    int old = ((Integer)table.getValueAt(row, 5)).intValue();
    table.setValueAt(new Integer(old + 1), row, 5);
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private JScrollPane scrollPane;
  private JTable table;
  // End of variables declaration//GEN-END:variables
}
