/* Generated by Together */

package strategy;

import jade.content.lang.sl.SLCodec;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPANames;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import java.util.Iterator;
import java.util.Vector;
import strategy.onto.GamingOntology;
import strategy.onto.StrategyDescription;

public class StrategyRepository extends Agent {
  public StrategyRepository() {
    super();
  }

  public Strategy getStrategy(StrategyDescription description) {
    Strategy result = null;
    Strategy temp;
    Iterator iterator = strategies.iterator();
    while (iterator.hasNext() && result == null) {
      temp = (Strategy)iterator.next();
      if (temp.getDescription().equals(description)) result = temp;
    }
    return result;
  }

  public StrategyDescription[] getStrategies(String game) {
    Vector v = new Vector();
    StrategyDescription temp;
    Iterator iterator = strategies.iterator();
    while (iterator.hasNext()) {
      temp = ((Strategy)iterator.next()).getDescription();
      if (temp.getGame().equalsIgnoreCase(game)) v.add(temp);
    }
    return (StrategyDescription[]) v.toArray(new StrategyDescription[0]);
  }

  public StrategyDescription[] getStrategiesByRisk(String game, int risk) {
    Vector v = new Vector();
    StrategyDescription temp;
    Iterator iterator = strategies.iterator();
    while (iterator.hasNext()) {
      temp = ((Strategy)iterator.next()).getDescription();
      if (temp.getGame().equalsIgnoreCase(game) && (temp.getRisk() == risk))
        v.add(temp);
    }
    return (StrategyDescription[]) v.toArray(new StrategyDescription[0]);
  }

  public Strategy getMostSuccessfullStrategy(String game) {
    Strategy result = null;
    Strategy temp;
    StrategyDescription desc;
    Iterator iterator = strategies.iterator();
    while (iterator.hasNext()) {
      temp = (Strategy)iterator.next();
      desc = temp.getDescription();
      if (desc.getGame().equalsIgnoreCase(game) && (result == null || result.winRatio() < temp.winRatio()))
        result = temp;
    }
    return result;
  }

  public void addStrategy(Strategy strategy) {
    if (getStrategy(strategy.getDescription()) == null) {
      strategies.add(strategy);
      StrategyDescription sd = strategy.getDescription();
      window.newRow(sd.getGame(), sd.getName(), sd.getRisk(), strategy.getWins(), strategy.getLosses());
    }
  }

  protected void setup() {
    getContentManager().registerLanguage(new SLCodec());
    getContentManager().registerOntology(GamingOntology.getInstance());
    DFAgentDescription dfad = new DFAgentDescription();
    dfad.addLanguage(FIPANames.ContentLanguage.FIPA_SL);
    dfad.addOntology(GamingOntology.ONTOLOGY_NAME);
    dfad.addProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);
    dfad.setName(getAID());
    ServiceDescription sd = new ServiceDescription();
    sd.addOntology(GamingOntology.ONTOLOGY_NAME);
    sd.setType("REPOSITORY");
    sd.setName(getName());
    dfad.addServices(sd);
    // Registrierung senden
    try {
      DFService.register(this, dfad);
    } catch (FIPAException e) {
      e.printStackTrace();
    }
    addBehaviour(new HandleInforms(this));
    addBehaviour(new HandleRequests(this));
  }

  public void addUse(String game, String name) {
    window.addUse(game, name);
  }

  public void addWin(StrategyDescription sd) {
    Strategy st = getStrategy(sd);
    st.addWin();
    window.setWins(sd.getGame(), sd.getName(), st.getWins());
  }

  public void addLoss(StrategyDescription sd) {
    Strategy st = getStrategy(sd);
    st.addLoss();
    window.setLosses(sd.getGame(), sd.getName(), st.getLosses());
  }

  private Vector strategies = new Vector();
  private RepositoryWindow window = new strategy.RepositoryWindow();
}
