package viergewinnt;

import gamehost.AbsGameHost;
import jade.core.AID;
import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import java.util.Random;
import java.util.StringTokenizer;

class C4EvaluateMove extends OneShotBehaviour {
  private C4GameHost gameHost;
  private int exitCode;
  private Random rnd = new Random();

  public C4EvaluateMove(C4GameHost a) {
    super(a);
    gameHost = a;
  }

  public void action() {
    AID currentPlayer = gameHost.getCurrentPlayer();
    AID lastPlayer = gameHost.getLastPlayer();
    C4Move lastMove = gameHost.getLastMove();
    if (lastMove != C4GameHost.FIRST_TURN) {
      gameHost.println(currentPlayer.getLocalName() + ": Bitte machen Sie ihren Zug! ");
    } else {
      gameHost.println("Neues Spiel! " + currentPlayer.getLocalName() + ": Bitte machen Sie ihren Zug!");
    }
    // ***** Zugaufforderung an nchsten Spieler senden *****
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(currentPlayer);
    msg.setContent("YourTurn");
    // msg.setLanguage("welcheLanguage");
    // msg.setOntology("welcheOntology");
    myAgent.send(msg);
    // HIER MSSTE MAN AM BESTEN NOCH EINE "OK"-NACHRICHT VON SENDMOVE ALS BESTTIGUNG EINFGEN
    msg.setContent(lastMove.toString()); // an dieser Stelle Konvertierung des Integer-Wert in String
    myAgent.send(msg);
    // ***** Zug vom Spieler empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    MessageTemplate m2 = MessageTemplate.MatchSender(currentPlayer);
    MessageTemplate m3 = MessageTemplate.and(m1, m2);
    // blockingReceive: es wird beliebig lang auf eine spezifische Nachricht gewartet
    ACLMessage turn = myAgent.blockingReceive(m3);
    // ***** Auswertung der Zuganweisung *****
    // erwartet wird vom Player entweder "Wuerfeln" oder "Zweifeln"
    String zugString = turn.getContent();
    StringTokenizer zugKoordinaten = new StringTokenizer(zugString);
    int xWert = Integer.parseInt(zugKoordinaten.nextToken());
    int yWert = Integer.parseInt(zugKoordinaten.nextToken());
    int farbWert = Integer.parseInt(zugKoordinaten.nextToken());
    C4Move newMove = new C4Move(xWert, yWert, farbWert);
    gameHost.println(currentPlayer.getLocalName() + " macht folgenden Zug: (" + xWert + "," + yWert + "," + farbWert + ")");
    gameHost.setMove(newMove);
    gameHost.incrementPlayerZaehler();

    boolean vierer = gameHost.viererErreicht();
    boolean weiter = gameHost.zugMoeglich();

    if (vierer) {
      //wer ist der Gewinner?
      AID winner = currentPlayer;
      gameHost.println(winner.getLocalName() + " hat gewonnen! Glckwunsch, stark gespielt!");
      gameHost.setWinner(winner);
      exitCode = AbsGameHost.GAME_OVER;
      // gameHost.printPoints();
    } else
    if (!weiter)
    {
		gameHost.println("UNENTSCHIEDEN! (Golden Goal??)");
      	gameHost.setWinner(null);
      	exitCode = AbsGameHost.GAME_OVER;
	}
	else
    {
		exitCode = AbsGameHost.GAME_NOT_OVER;
    }
  }

  public int onEnd() {
    return exitCode;
  }
}
