package viergewinnt;

import gamehost.AbsGameHost;
import gamehost.GameHostWindow;
import jade.core.AID;
import java.util.Random;
import jess.JessException;
import jess.RU;
import jess.Rete;
import jess.Value;
import strategy.Strategy;
import strategy.onto.StrategyDescription;


public class C4GameHost extends AbsGameHost {
  // private Vector points = new Vector();
  // private final int START_POINTS = 3;
  private GameHostWindow textWin;
  public static final C4Move FIRST_TURN = new C4Move(0, 0, 0);
  private C4Move lastMove;
  private AID lastPlayer;
  private Random rnd = new Random();
  private Rete jessBasis;


  /** Creates new C4GameHost */
  public C4GameHost() {
    super();
    maxPlayers = 2;
    maxGames = 2;
    game = "Vier Gewinnt";
    fee = 5;
    prize = 10;
    //try {
      // ist in der reset methode...
      //jessBasis.executeCommand("(batch c4regeln.clp)");
      //jessBasis.executeCommand("(facts)");
    //} catch (JessException re) {
    //  re.printStackTrace();
    //}
    textWin = new GameHostWindow(game);
    // ***** Fr jede Strategie eine Beschreibung erstellen *****
    //makeMoveBehaviour = new Strategy[3];
    makeMoveBehaviour = new Strategy[3];

    StrategyDescription sd = new StrategyDescription();
    sd.setGame(game);
    sd.setName("Offensiv1");
    sd.setRisk(2);
    makeMoveBehaviour[0] = new Strategy(sd, new C4SendMoveOff1(null));

    sd = new StrategyDescription();
    sd.setGame(game);
    sd.setName("Offensiv2");
    sd.setRisk(2);
    makeMoveBehaviour[1] = new Strategy(sd, new C4SendMoveOff2(null));

    sd = new StrategyDescription();
    sd.setGame(game);
    sd.setName("Defensiv");
    sd.setRisk(1);
    makeMoveBehaviour[2] = new Strategy(sd, new C4SendMoveDef(null));
    evaluateMoveBehaviour = new C4EvaluateMove(this);
  }

    /* public boolean viererErreicht() {
		System.out.print("(GameHost, Vierer-Test) JESS-Anbindung beginnt ...");
		Regelbasis.executeCommand("(viererErreicht)");
		Value v = Regelbasis.executeCommand("(run)");
		System.out.println("JESS-Ergebnis: " + v.stringValue(mirko.getGlobalContext()));

		System.out.println("JESS-Anbindung fertig ...");
		return false;
	} */

  public void setMove(C4Move newMove) {
    lastMove = newMove;
    print("GameHost traegt Zug von Spieler in JESS-WB ein ... ");
    int spalte = newMove.getX();
    int farbe = newMove.getFarbe();
    try {
      jessBasis.store("XKoordinate", new Value(spalte, RU.INTEGER));
      jessBasis.store("Farbe", new Value(farbe, RU.INTEGER));
      // Value zurueck =
      Value zurueck = jessBasis.executeCommand("(SteinHinzuSpalte (fetch XKoordinate) (fetch Farbe))");
      if (zurueck.intValue(jessBasis.getGlobalContext()) != 0)
      {
		  newMove.setY(zurueck.intValue(jessBasis.getGlobalContext()) % 10);
		  print("mit folgendem Wert: " + newMove.getX() + "," + newMove.getY());

	  } else
	  {
		  println("doch nicht! Fehler!");

	  }

    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
    println("fertig!");
    // println(zurueck.stringValue(jessBasis.getGlobalContext()) + ")");
  }

  public boolean zugMoeglich() {
    boolean moeglich = false;
    print("GameHost: freie Felder? ... ");
    Value zurueck = null;
    try {
      zurueck = jessBasis.executeCommand("(FelderFrei)");
    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
    try {
      if (zurueck.intValue(jessBasis.getGlobalContext()) == 0) {
        println("fertig! Kein Feld mehr frei, unentschieden!");
        moeglich = false;
      } else {
        println("fertig! Noch " + zurueck.intValue(jessBasis.getGlobalContext()) + " Felder frei!");
        moeglich = true;
      }
    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
    return moeglich;
  }

  public boolean viererErreicht() {
    print("GameHost untersucht Spielfeld nach VIERER ... ");
    boolean vier = false;
    Value zurueck = null;
    try {
      zurueck = jessBasis.executeCommand("(Vierer)");
    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
    try {
      if (zurueck.intValue(jessBasis.getGlobalContext()) == 0) {
        println("fertig! (kein Vierer gefunden)");
        vier =  false;
      } else {
        println("fertig! (Vierer gefunden, Farbe " + zurueck.intValue(jessBasis.getGlobalContext()) + ")");
        vier = true;
      }
    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
    return vier;
  }

  public void finishGame() {
    super.finishGame();
  }

  public void resetGame() {
    super.resetGame();
    lastMove = FIRST_TURN;
    lastPlayer = null;
    // JESS-Engine erneuern
    try {
      jessBasis = new Rete();
      jessBasis.clear();
      jessBasis.reset();
      jessBasis.executeCommand("(batch viergewinnt/c4regeln.clp)");
      // jessBasis.executeCommand("(facts)");
    } catch (JessException ex) {
      System.out.println("JessException");
      ex.printStackTrace();
    }
  }

  public boolean addPlayer(AID p) {
    if (super.addPlayer(p)) {
      // points.addElement(new Integer(START_POINTS));
      return true;
    } else
      return false;
  }

  public boolean deletePlayer(AID p) {
    int pos = players.indexOf(p);
    // if (pos >= 0) points.removeElementAt(pos);

        /*ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
        msg.setSender(getAID());
        msg.addReceiver(p);
        msg.setContent("GameOver");
        send(msg);*/

    return super.deletePlayer(p);
  }

  //public AID getNextPlayer() {}
  public AID getLastPlayer() { return lastPlayer; }

  public void setLastPlayer(AID p) { lastPlayer = p; }

    /*
     public void printPoints() {
        println();
        println("*** Spielstand ***");
        for (int i = 0; i < players.size(); i++)
            println(((AID) players.elementAt(i)).getLocalName() + ": " +
            ((Integer) points.elementAt(i)).intValue());
        println();
    }
    */




  public C4Move getLastMove() {
    return lastMove;
  }

  public void print(String text) {
    textWin.print(text);
  }

  public void println(String text) {
    textWin.println(text);
  }

  public void println() {
    textWin.println();
  }
}
