package viergewinnt;

import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import java.util.ArrayList;
import java.util.*;
import java.util.Iterator;
import java.util.Random;
import java.util.StringTokenizer;
import jess.Fact;
import jess.JessException;
import jess.RU;
import jess.Rete;
import jess.Token;
import jess.Value;
import jess.ValueVector;
import player.CheckCredits;
import player.Player;

class C4SendMoveDef extends OneShotBehaviour {
  //hier steht der inhalt der Nachricht nach einem empfangen()
  String msgcontent;
  // hier steht der Move des Vorgngerspielers als String nach empfangen()
  String msgmove;
  // Move vom Vorgnger
  C4Move vorgaenger;
  // mein eigener neuer Move
  C4Move meiner;
  int zustand;
  private Random rnd = new Random();
  final int MY_TURN = 1;
  final int WON = 2;
  final int LOST = 3;
  final int DRAW = 4;
  final int UNKNOWN = 5;
  private Rete intelligenz;
  int meineFarbe = 0;
  int gegnerFarbe;

  public C4SendMoveDef(Player a) {
    super(a);
    try {
      intelligenz = new Rete();
      intelligenz.clear();
      intelligenz.reset();
      intelligenz.executeCommand("(batch viergewinnt/c4regeln.clp)");
      // intelligenz.executeCommand("(facts)");
    } catch (JessException ex) {
      System.out.println("Jess Exception aufgetreten in C4SendMoveOff1...");
      ex.printStackTrace();
    }
  }

  public void action() {
     zustand = zustandsWechsel();
    // solange Spiel nicht zuende
    while ((zustand != WON) && (zustand != LOST) && (zustand != DRAW)) {
      switch (zustand) {
        case MY_TURN: {
            meiner = generateMovefeatJESS();
            setMove(meiner);
            moveSenden(meiner);
            break;
          }
        case UNKNOWN: {
            //da der Zustand unbekannt ist... einfach auf andere Nachricht warten
            break;
          }
      }
      zustand = zustandsWechsel();
    } //while
    if (zustand == WON) ((Player)myAgent).sendWon();
    else if (zustand == LOST) ((Player)myAgent).sendLost();
    else if (zustand == DRAW) ((Player) myAgent).sendLost();
    myAgent.addBehaviour(new CheckCredits(myAgent));
  }

  private void empfangen() {
    // ***** Nachricht vom GameHost empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    MessageTemplate m3 = MessageTemplate.MatchSender(((Player)myAgent).getHost());
    MessageTemplate m5 = MessageTemplate.and(m1, m3);
    // receive: Warten auf Nachricht von GameHost
    ACLMessage msg = myAgent.blockingReceive(m5);
    // ***** Nachricht auswerten *****
    // hier einfach, da einfaches Wrfelspiel
    msgcontent = msg.getContent();
    if (msgcontent.equalsIgnoreCase("YourTurn")) {
      msg = myAgent.blockingReceive(m5);
      msgmove = msg.getContent();
      StringTokenizer zugKoordinaten = new StringTokenizer(msgmove);
      int xWert = Integer.parseInt(zugKoordinaten.nextToken());
      int yWert = Integer.parseInt(zugKoordinaten.nextToken());
      int farbWert = Integer.parseInt(zugKoordinaten.nextToken());
      if (xWert==0 && yWert==0 && farbWert==0) {
        meineFarbe = 1;
        gegnerFarbe = 2;
      } else if (meineFarbe==0) {
        meineFarbe = 2;
        gegnerFarbe = 1;
      }
      if (xWert==0 && yWert==0 && farbWert==0) {
      } else {
        vorgaenger = new C4Move(xWert, yWert, farbWert);
        setMove(vorgaenger);
      }
    }
  }

  public void setMove(C4Move newMove) {
    System.out.println("Player traegt einen Zug in seine JESS-WB ein ... ");
    int spalte = newMove.getX();
    int farbe = newMove.getFarbe();
    try {
      intelligenz.store("XKoordinate", new Value(spalte, RU.INTEGER));
      intelligenz.store("Farbe", new Value(farbe, RU.INTEGER));
    } catch (JessException ex) {
      System.out.println("JessException aufgetreten in setMove...");
      ex.printStackTrace();
    }
    // Value zurueck =
    try {
      intelligenz.executeCommand("(SteinHinzuSpalte (fetch XKoordinate) (fetch Farbe))");
    } catch (JessException ex) {
      System.out.println("JessException aufgetreten in setMove...");
      ex.printStackTrace();
    }
    System.out.println("fertig!");
    // println(zurueck.stringValue(intelligenz.getGlobalContext()) + ")");
  }

  private int zustandsWechsel() {
    int zst;
    empfangen();
    //if anweisung weil switch leider nur int untersttzt...
    if (msgcontent.equalsIgnoreCase("YourTurn")) {
      zst = MY_TURN;
      //break;
    } else if (msgcontent.equalsIgnoreCase("Won")) {
      zst = WON;
      //break;
    } else if (msgcontent.equalsIgnoreCase("Lost")) {
      zst = LOST;
      //break;
    } else if (msgcontent.equalsIgnoreCase("Draw")) {
      zst = DRAW;
      //break;
    } else { zst = UNKNOWN; }
    return zst;
  }

  private C4Move generateMovefeatJESS() {
   System.out.println("Move generieren mit Strategie DEFENSIV");

   Iterator ergebnisMenge = null;
   ArrayList v = null;
   int zufallszahl;
   boolean moveFertig = false;
   Value temp;
   int ergebnisvorhanden;
   C4Move myMove = new C4Move(0, 0, meineFarbe);
   try {
     intelligenz.store("FarbeIch", new Value(meineFarbe, RU.INTEGER));
     intelligenz.store("FarbeGegner", new Value(gegnerFarbe, RU.INTEGER));
     intelligenz.store("Anzahl2", new Value(2, RU.INTEGER));
     intelligenz.store("Anzahl3", new Value(3, RU.INTEGER));
     temp = intelligenz.executeCommand("(PruefenMehrMoeglichTemp (fetch FarbeIch) (fetch Anzahl3))");
     ergebnisvorhanden = temp.intValue(intelligenz.getGlobalContext());
     if (ergebnisvorhanden==1){
       intelligenz.executeCommand("(store RESULT (PruefenMehrMoeglichMaster (fetch FarbeIch) (fetch Anzahl3)))");
       ergebnisMenge = (Iterator)intelligenz.fetch("RESULT").externalAddressValue(intelligenz.getGlobalContext());
       v = new ArrayList();
       if (ergebnisMenge.hasNext()) {
         Token t = (Token)ergebnisMenge.next();
         Fact f = t.fact(2);
         ValueVector multislot = f.get(0).listValue(intelligenz.getGlobalContext());
         System.out.println("Spieler erkennt Moeglichkeit bei (" + multislot.get(0).intValue(intelligenz.getGlobalContext()) + "," +
                            multislot.get(1).intValue(intelligenz.getGlobalContext()) + ")!");
         myMove.setX(multislot.get(0).intValue(intelligenz.getGlobalContext()));
         myMove.setY(multislot.get(1).intValue(intelligenz.getGlobalContext()));
         moveFertig = true;

       }
     }


                       /*
                       // dieser Schleife knnte benutzt werden, um alle Mglichkeiten einzusammeln
                       while (ergebnisMenge.hasNext())
                       {
                               Token t = (Token) ergebnisMenge.next();

                               // uns interessiert der zweite Fakt eines Treffers, dieser gibt das leere Feld an (also die Mglichkeit)
                               Fact f = t.fact(1);

                               // Alle Daten in diesem Fakt stehen in einem MultiSlot
                               ValueVector multislot = f.get(0).listValue(null);

                               // The second element of this slot is the datum we're interested in.
                               System.out.println("Moeglichkeit bei (" + multislot.get(1).intValue(null) + "," + multislot.get(2).intValue(null) + ")!");
                       }
                       */

     if (!moveFertig) {
       temp = intelligenz.executeCommand("(PruefenMehrMoeglichTemp (fetch FarbeGegner) (fetch Anzahl3))");
       ergebnisvorhanden = temp.intValue(intelligenz.getGlobalContext());
       if (ergebnisvorhanden==1){
         intelligenz.executeCommand("(store RESULT (PruefenMehrMoeglichMaster (fetch FarbeGegner) (fetch Anzahl3)))");
         ergebnisMenge = (Iterator)intelligenz.fetch("RESULT").externalAddressValue(intelligenz.getGlobalContext());

         v = new ArrayList();
         if (ergebnisMenge.hasNext()) {
           Token t = (Token)ergebnisMenge.next();
           Fact f = t.fact(2);
           ValueVector multislot = f.get(0).listValue(intelligenz.getGlobalContext());
           System.out.println("Spieler erkennt VIERER-Bedrohung bei (" + multislot.get(0).intValue(intelligenz.getGlobalContext()) + "," +
                              multislot.get(1).intValue(intelligenz.getGlobalContext()) + ")!");
           myMove.setX(multislot.get(0).intValue(intelligenz.getGlobalContext()));
           myMove.setY(multislot.get(1).intValue(intelligenz.getGlobalContext()));
           moveFertig = true;
         }
       }
     }
     if (!moveFertig) {
       // System.out.println("Suche nach einem moeglichen Dreier");
       temp = intelligenz.executeCommand("(PruefenMehrMoeglichTemp (fetch FarbeGegner) (fetch Anzahl2))");
       ergebnisvorhanden = temp.intValue(intelligenz.getGlobalContext());
       if (ergebnisvorhanden==1){
		   	// System.out.println("Dreier-Suche scheint erfolgreich zu sein");
         	Value neuerValue = intelligenz.executeCommand("(PruefenMehrMoeglichMaster (fetch FarbeGegner) (fetch Anzahl2))");
         	ergebnisMenge = (Iterator) neuerValue.externalAddressValue(intelligenz.getGlobalContext());


         if (ergebnisMenge.hasNext()) {
           Token t = (Token)ergebnisMenge.next();
           Fact f = t.fact(2);
           ValueVector multislot = f.get(0).listValue(intelligenz.getGlobalContext());
           System.out.println("Spieler erkennt DREIER Bedrohung bei (" + multislot.get(0).intValue(intelligenz.getGlobalContext()) + "," +
                              multislot.get(1).intValue(intelligenz.getGlobalContext()) + ")!");
           myMove.setX(multislot.get(0).intValue(intelligenz.getGlobalContext()));
           myMove.setY(multislot.get(1).intValue(intelligenz.getGlobalContext()));
           moveFertig = true;
         }
         else
         {
			 //System.out.println("Bei der Dreier-Suche ist irgendwas schiefgegangen");

		 }

         //System.out.println("Dreier-Suche beendet");
       }
     }
     if (!moveFertig) {
       // System.out.println("Spieler hat keine regelbasierten Hinweise erhalten. Zufalls-Spalte!");
       boolean spalteFrei = false;
       while (!spalteFrei) {
         rnd = new Random();
         zufallszahl = rnd.nextInt(7) + 1;
         intelligenz.store("TestSpalte", new Value(zufallszahl, RU.INTEGER));
         Value zurueck = intelligenz.executeCommand("(PruefenSpalte (fetch TestSpalte))");
         if (zurueck.intValue(intelligenz.getGlobalContext()) == 1) {
           System.out.println("Super. Nur Zufalls-Spalte gefunden.");
           spalteFrei = true;
         }
         myMove.setX(zufallszahl);
       }
       moveFertig = true;
     }
   } catch (JessException je) {
     je.printStackTrace();
   }
   return myMove;
  }

  private void moveSenden(C4Move meinMove) {
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getHost());
    // meinen Zug in einen String umwandeln und loschicken
    msg.setContent(meinMove.toString());
    myAgent.send(msg);
  }
}
