package viergewinnt;

import jade.core.AID;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import java.util.Iterator;
import jess.Fact;
import jess.JessException;
import jess.RU;
import jess.Rete;
import jess.Token;
import jess.Value;
import jess.ValueVector;

/**
 * @author  Mirko Brueckner
 * @version
 */
public class JessTestPlayer extends Agent {
  private DFAgentDescription[] hosts = null; // Liste mit allen Hosts
  private int currentHostNo = 0; // Host, bei dem gerade die Anmeldung versucht wird/gespielt wird

  /** Creates new Player */
  public JessTestPlayer() {
    super();
  }

  protected void setup() {
    // beim DF registrieren
    DFAgentDescription dfad = new DFAgentDescription();
    ServiceDescription sd = new ServiceDescription();
    sd.setName(getName());
    sd.addOntology("GAMING");
    sd.setType("PLAYER");
    dfad.setName(getAID());
    dfad.addServices(sd);
    dfad.addOntology("GAMING");
    try {
      DFService.register(this, dfad);
    } catch (FIPAException e) {
      System.err.println(getLocalName() + ": registration with DF failed. Killing myself.");
      doDelete();
    }
    System.out.println("Beginne nun mit JESS-Anbindung ...");
    try {
      Rete intelligenz = new Rete();
      intelligenz.executeCommand("(batch c4regeln.clp)");
      intelligenz.store("FarbeIch", new Value(2, RU.INTEGER));
      intelligenz.store("FarbeGegner", new Value(1, RU.INTEGER));
      intelligenz.store("Anzahl2", new Value(2, RU.INTEGER));
      intelligenz.store("Anzahl3", new Value(3, RU.INTEGER));
      // intelligenz.store("RESULT", intelligenz.runQuery("MehrMoeglichDiagonal1Var", new ValueVector().add(new Value(2,
      // RU.INTEGER)).add(new Value(3, RU.INTEGER)) ));
      intelligenz.executeCommand("(store RESULT (PruefenMehrMoeglichMaster (fetch FarbeIch) (fetch Anzahl3)))");
      Iterator e = (Iterator)intelligenz.fetch("RESULT").externalAddressValue(null);
      // ArrayList v = new ArrayList();
      // Pick each element of the Iterator apart and store the
      // interesting part in the ArrayList v.
      while (e.hasNext()) {
        Token t = (Token)e.next();
        // We want the second fact in the token - the first is the query trigger
        Fact f = t.fact(1);
        // The first and only slot of this fact is the __data multislot.
        ValueVector multislot = f.get(0).listValue(null);
        // The second element of this slot is the datum we're interested in.
        System.out.println("Moeglichkeit bei (" + multislot.get(1).intValue(null) + "," +
            multislot.get(2).intValue(null) + ")!");
      }
      //for (Iterator answers = v.iterator(); answers.hasNext();)
      //	System.out.println(answers.next());
      // System.out.println("Antwort ist: " + intelligenz.fetch("RESULT"));
      System.out.println("JESS-Anbindung ausgefuehrt...");
    } catch (JessException e) {
      System.err.println(e);
      System.out.println("JESS-Anbindung offensichtlich fehlgeschlagen ...");
    }
    System.out.println();
    System.out.println("JESS-Anbindung fertig");
  }

  public void takeDown() {
    try {
      DFService.deregister(this);
    } catch (FIPAException e) {
      System.err.println(getLocalName() + ": error while deregistering.");
    }
  }

  public DFAgentDescription[] getHosts() { return hosts; }

  public void setHosts(DFAgentDescription[] dfad) { hosts = dfad; }

  public int getCurrentHostNo() { return currentHostNo; }

  public void setCurrentHostNo(int chn) { currentHostNo = chn; }

  public AID getCurrentHost() throws ArrayIndexOutOfBoundsException /*, NullPointerException */ {
    return hosts[currentHostNo].getName();
  }

  public void incrementCurrentHostNo() { currentHostNo++; }
}
