;;(deftemplate Feld
;;	"Ein einzelnes Kaestchen des Spielfelds"
;;(slot XKoordinate)
;;(slot YKoordinate)
;;(slot Inhalt (default 0)))


;; ===============================
;; SPIELFELD AUFBAUEN DURCH FAKTEN ERSTELLEN
;; ===============================

(bind ?X 1)
(while (< ?X 8)
	(bind ?Y 1)
	(while (< ?Y 7)
		(assert (Feld ?X ?Y 0))
		(bind ?Y (+ ?Y 1)))
	(bind ?X (+ ?X 1)))



;; ===============================
;; QUERYs, WERDEN SPTER IN DN FUNKTIONEN BENUTZT (siehe auch REGELN)
;; ===============================


(defquery FindeFeld
	(declare (variables ?A ?B))
	(Feld ?A ?B ?C)
	) ;; defquery
	
(defquery FindeFeldLeer
	(declare (variables ?A ?B))
	(Feld ?A ?B 0)
	) ;; defquery

(defquery leereFelder
	(Feld ?A ?B 0)
	) ;; defquery
	
(defquery Vierer
	(Zusammen 4 ?wie ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	) ;; defquery
	

;; ============================================
(defquery LueckeHorizontal
	(declare (variables ?Farbe))
	(or	(and	(Feld ?Spalte1 1 0)
			(Feld ?Spalte2&:(= ?Spalte2 (- ?Spalte1 1)) 1 ?Farbe)
			(Feld ?Spalte3&:(= ?Spalte3 (+ ?Spalte1 1)) 1 ?Farbe)
		) ;; and
		
		(and	(Feld ?Spalte1 ?Zeile 0)
			(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
			(Feld ?Spalte3&:(= ?Spalte3 (- ?Spalte1 1)) ?Zeile ?Farbe)
			(Feld ?Spalte4&:(= ?Spalte4 (+ ?Spalte1 1)) ?Zeile ?Farbe)
		) ;; and
		
	) ;; or
	
	) ;; defquery

(defquery LueckeDiagonal1
	(declare (variables ?Farbe))
	(Feld ?Spalte1 ?Zeile 0)
	(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
	(Feld ?Spalte3&:(= ?Spalte3 (+ ?Spalte1 1)) ?Zeile3&:(= ?Zeile3 (+ ?Zeile 1)) ?Farbe)
	(Feld ?Spalte4&:(= ?Spalte4 (- ?Spalte1 1)) ?Zeile4&:(= ?Zeile4 (- ?Zeile 1)) ?Farbe)
	
	
	) ;; defquery
	
(defquery LueckeDiagonal2
	(declare (variables ?Farbe))
	(Feld ?Spalte1 ?Zeile 0)
	(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
	(Feld ?Spalte3&:(= ?Spalte3 (- ?Spalte1 1)) ?Zeile3&:(= ?Zeile3 (+ ?Zeile 1)) ?Farbe)
	(Feld ?Spalte4&:(= ?Spalte4 (+ ?Spalte1 1)) ?Zeile4&:(= ?Zeile4 (- ?Zeile 1)) ?Farbe)
	
	
	) ;; defquery

(defquery LueckeMaster
	(declare (variables ?Farbe))
	(or	(and	(Feld ?Spalte1 ?Zeile 0)
			(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
			(Feld ?Spalte3&:(= ?Spalte3 (- ?Spalte1 1)) ?Zeile3&:(= ?Zeile3 (+ ?Zeile 1)) ?Farbe)
			(Feld ?Spalte4&:(= ?Spalte4 (+ ?Spalte1 1)) ?Zeile4&:(= ?Zeile4 (- ?Zeile 1)) ?Farbe)
	
		) ;; and
		
		(and	(Feld ?Spalte1 ?Zeile 0)
			(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
			(Feld ?Spalte3&:(= ?Spalte3 (+ ?Spalte1 1)) ?Zeile3&:(= ?Zeile3 (+ ?Zeile 1)) ?Farbe)
			(Feld ?Spalte4&:(= ?Spalte4 (- ?Spalte1 1)) ?Zeile4&:(= ?Zeile4 (- ?Zeile 1)) ?Farbe)
			
		) ;; and
		
		(and	(Feld ?Spalte1 1 0)
			(Feld ?Spalte2&:(= ?Spalte2 (- ?Spalte1 1)) 1 ?Farbe)
			(Feld ?Spalte3&:(= ?Spalte3 (+ ?Spalte1 1)) 1 ?Farbe)
		) ;; and
		
		(and	(Feld ?Spalte1 ?Zeile 0)
			(Feld ?Spalte1 ?Zeile2&:(= ?Zeile2 (- ?Zeile 1)) ?Farbe2&~0)
			(Feld ?Spalte3&:(= ?Spalte3 (- ?Spalte1 1)) ?Zeile ?Farbe)
			(Feld ?Spalte4&:(= ?Spalte4 (+ ?Spalte1 1)) ?Zeile ?Farbe)
		) ;; and
		
	
	) ;; or	
	
	) ;; defquery


;; ============================================

(defquery MehrMoeglichHorizontal
	(declare (variables ?Farbe))
	(Zusammen ?A h ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?ZeileA 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)
		
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?ZeileA 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)
		
	) ;; or
	) ;; defquery


(defquery MehrMoeglichVertikal
	(declare (variables ?Farbe))
	(Zusammen ?A v ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(Feld ?SpalteA ?FeldYWert&:(= ?FeldYWert (+ ?ZeileE 1)) 0)
	
	) ;; defquery
	

(defquery MehrMoeglichDiagonal1
	(declare (variables ?Farbe))
	(Zusammen ?A d1 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)
			
		) ;; and
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
		) ;; and
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)
		
		
				
	) ;; or
	
	) ;; defquery

(defquery MehrMoeglichDiagonal2
	(declare (variables ?Farbe))
	(Zusammen ?A d2 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)
			
		) ;; and
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
		) ;; and
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)
		
		
				
	) ;; or
	
	) ;; defquery

;; ============================================

(defquery MehrMoeglichHorizontalVar
	(declare (variables ?Farbe ?Anzahl))
	(Zusammen ?Anzahl h ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?ZeileA 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)
		
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?ZeileA 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)
		
	) ;; or
	) ;; defquery


(defquery MehrMoeglichVertikalVar
	(declare (variables ?Farbe ?Anzahl))
	(Zusammen ?Anzahl v ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(Feld ?SpalteA ?FeldYWert&:(= ?FeldYWert (+ ?ZeileE 1)) 0)
	
	) ;; defquery
	

(defquery MehrMoeglichDiagonal1Var
	(declare (variables ?Farbe ?Anzahl))
	(Zusammen ?Anzahl d1 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)
			
		) ;; and
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
		) ;; and
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)
		
		
				
	) ;; or
	
	) ;; defquery

(defquery MehrMoeglichDiagonal2Var
	(declare (variables ?Farbe ?Anzahl))
	(Zusammen ?Anzahl d2 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
	(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)
			
		) ;; and
		
		(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
			(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
		) ;; and
		
		(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)
		
		
				
	) ;; or
	
	) ;; defquery

;; ===============================	

(defquery MehrMoeglichMasterVar
	(declare (variables ?Farbe ?Anzahl))
	(or	(and	(Zusammen ?Anzahl d2 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
			(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)

				) ;; and

				(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
				) ;; and

				(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)



			) ;; or
		) ;; and
		
		(and	(Zusammen ?Anzahl d1 ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
			(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert (+ ?ZeileE 1)) 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?ZeileE ?Feld2Farbe&~0)

				) ;; and

				(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1)) 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 2)) ?Feld2Farbe&~0)
				) ;; and

				(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert (- ?ZeileA 1))&:(= ?Feld1YWert 1) 0)



			) ;; or
		) ;; and
		
		(and	(Zusammen ?Anzahl v ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
			(Feld ?SpalteA ?FeldYWert&:(= ?FeldYWert (+ ?ZeileE 1)) 0)
		
		) ;; and
		
		(and	(Zusammen ?Anzahl h ?SpalteA ?ZeileA ?SpalteE ?ZeileE ?Farbe)
			(or	(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?ZeileA 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (- ?SpalteA 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )

				(Feld ?Feld1XWert&:(= ?Feld1XWert (- ?SpalteA 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)


				(and	(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?ZeileA 0)
					(Feld ?Feld2XWert&:(= ?Feld2XWert (+ ?SpalteE 1)) ?Feld2YWert&:(= ?Feld2YWert (- ?ZeileA 1)) ?Feld2Farbe&~0) )

				(Feld ?Feld1XWert&:(= ?Feld1XWert (+ ?SpalteE 1)) ?Feld1YWert&:(= ?Feld1YWert ?ZeileA)&:(= ?Feld1YWert 1) 0)

			) ;; or
		) ;; and
	
	) ;; or

	) ;; defquery



;; ===============================
;; FUNKTIONEN
;; ===============================

(deffunction FelderFrei ()
	(printout t "Pruefe auf freie Felder in JESS ..." crlf)
	(printout t "...Ergebnis: " (count-query-results leereFelder) " leere Felder!" crlf)
	(return (count-query-results leereFelder))
	) ;; deffunction
	

(deffunction SteinHinzuSpalte (?Spalte ?Farbe)
	(if (and	(= (PruefenSpalte ?Spalte) 1)	(or (= ?Farbe 2) (= ?Farbe 1)) ) then
		(bind ?Zeile 1)
		(bind ?Inhalt 1)
		(while (not (= ?Inhalt 0))
			(if (> (count-query-results FindeFeld ?Spalte ?Zeile) 0) then
				;;(printout t "Anzahl der Ergebnisse ist " (count-query-results FindeFeld ?Spalte ?Zeile) crlf)
				(bind ?it (run-query FindeFeld ?Spalte ?Zeile))
				(while (?it hasNext)
					(bind ?token (call ?it next))
					(bind ?id (call ?token fact 1))
					(bind ?slot (fact-slot-value ?id __data))
				) ;;while
				
				(bind ?Inhalt (nth$ 3 ?slot))
				;;(printout t "Inhalt-Ergebnis: " ?Inhalt crlf)
			) ;; if
			
			(bind ?Zeile (+ ?Zeile 1))
		) ;; while
		
		
		(bind ?YWert (nth$ 2 ?slot))
		
		;; (printout t "(JESS): Stein eingefuegt bei: (" ?Spalte "," ?YWert ")" crlf) 
							
		(assert (Feld ?Spalte ?YWert ?Farbe))
		
		(if (> (count-query-results FindeFeldLeer ?Spalte ?YWert) 0) then
			;; (printout t "Anzahl der Ergebnisse ist " (count-query-results FindeFeldLeer ?Spalte ?Zeile) crlf)
			(bind ?it (run-query FindeFeldLeer ?Spalte ?YWert))
			(while (?it hasNext)
				(bind ?token (call ?it next))
				(bind ?IDaltesFeld (call ?token fact 1))
			) ;;while
									
		) ;; if
		
		(retract ?IDaltesFeld)
		
		(return (+ ?YWert (* ?Spalte 10)))
	else
		(printout t "Falsche Farbe angegeben, oder Spalte ist voll!" crlf)
		(return 0)
		
	) ;; if
	
	) ;; feffunction
	
	

(deffunction PruefenSpalte (?S)
	;; (printout t "(JESS): Funktion PruefenSpalte begonnen ..." crlf)
	(if (> (count-query-results FindeFeldLeer ?S 6) 0) then
		;; (printout t "...true" crlf)
		(return 1)
		
	else
		;; (printout t "PruefenSpalte ... false" crlf)
		(return 0)
	) ;; if
	) ;; deffunction


(deffunction PruefenMehrMoeglich (?Farbe)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		(printout t " " crlf)
		(printout t "***** ANFRAGE NACH MOEGLICHEN ZUEGEN ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichVertikal ?Farbe) 0) then
			(printout t "Anzahl vertikaler Moeglichkeiten ist " (count-query-results MehrMoeglichVertikal ?Farbe) crlf)
			(bind ?treffer (run-query MehrMoeglichVertikal ?Farbe))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Feld (call ?token fact 2))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				
				(printout t "Moeglichkeit (zum vertikalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				
			) ;; while
		) ;; if
		
		
		;; ABFRAGE horizontaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichHorizontal ?Farbe) 0) then
			(printout t "Anzahl horizontaler Moeglichkeiten ist " (count-query-results MehrMoeglichHorizontal ?Farbe) crlf)
			(bind ?treffer (run-query MehrMoeglichHorizontal ?Farbe))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))
				
				
				(printout t "Moeglichkeit (zum horizontalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				;; restliche Ausgabe: ... Grund: Fakt " (call ?Feld toString)
				
			) ;; while
		) ;; if		
		
		;; ABFRAGE diagonaler Mglichkeiten (1)
		(if (> (count-query-results MehrMoeglichDiagonal1 ?Farbe) 0) then
			(printout t "Anzahl diagonaler Moeglichkeiten ist " (count-query-results MehrMoeglichDiagonal1 ?Farbe) crlf)
			(bind ?treffer (run-query MehrMoeglichDiagonal1 ?Farbe))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))
				
				
				(printout t "Moeglichkeit (zum diagonalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				;; restliche Ausgabe: ... Grund: Fakt " (call ?Feld toString)
				
			) ;; while
		) ;; if	
		
		
		;; ABFRAGE diagonaler Mglichkeiten (2)
		(if (> (count-query-results MehrMoeglichDiagonal2 ?Farbe) 0) then
			;; (printout t "Anzahl diagonaler Moeglichkeiten ist " (count-query-results MehrMoeglichDiagonal2 ?Farbe) crlf)
			(bind ?treffer (run-query MehrMoeglichDiagonal2 ?Farbe))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))
				
				
				(printout t "Moeglichkeit (zum diagonalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				
			) ;; while
		) ;; if		
		
		(printout t "***** Funktion fertig! *****" crlf)
		(printout t " " crlf)
		
					
	) ;; if
	) ;; deffunction


(deffunction PruefenMehrMoeglichVar (?Farbe ?A)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		(printout t " " crlf)
		(printout t "***** ANFRAGE NACH MOEGLICHEN ZUEGEN ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichVertikalVar ?Farbe ?A) 0) then
			(printout t "Anzahl vertikaler Moeglichkeiten ist " (count-query-results MehrMoeglichVertikalVar ?Farbe ?A) crlf)
			(bind ?treffer (run-query MehrMoeglichVertikalVar ?Farbe ?A))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Feld (call ?token fact 2))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				
				(printout t "Moeglichkeit (zum vertikalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				
			) ;; while
		) ;; if
		
		;; ABFRAGE horizontaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichHorizontalVar ?Farbe ?A) 0) then
			(printout t "Anzahl horizontaler Moeglichkeiten ist " (count-query-results MehrMoeglichHorizontalVar ?Farbe ?A) crlf)
			(bind ?treffer (run-query MehrMoeglichHorizontalVar ?Farbe ?A))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))


				(printout t "Moeglichkeit (zum horizontalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				;; restliche Ausgabe: ... Grund: Fakt " (call ?Feld toString)

			) ;; while
		) ;; if		

		;; ABFRAGE diagonaler Mglichkeiten (1)
		(if (> (count-query-results MehrMoeglichDiagonal1Var ?Farbe ?A) 0) then
			(printout t "Anzahl diagonaler Moeglichkeiten ist " (count-query-results MehrMoeglichDiagonal1Var ?Farbe ?A) crlf)
			(bind ?treffer (run-query MehrMoeglichDiagonal1Var ?Farbe ?A))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))


				(printout t "Moeglichkeit (zum diagonalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
				;; restliche Ausgabe: ... Grund: Fakt " (call ?Feld toString)

			) ;; while
		) ;; if	


		;; ABFRAGE diagonaler Mglichkeiten (2)
		(if (> (count-query-results MehrMoeglichDiagonal2Var ?Farbe ?A) 0) then
			;; (printout t "Anzahl diagonaler Moeglichkeiten ist " (count-query-results MehrMoeglichDiagonal2Var ?Farbe ?A) crlf)
			(bind ?treffer (run-query MehrMoeglichDiagonal2Var ?Farbe ?A))
			(while (?treffer hasNext)
				(bind ?token (call ?treffer next))
				(bind ?Zusammen (call ?token fact 1))
				(bind ?Feld (call ?token fact 2))
				(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
				(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
				(bind ?FeldSlot (fact-slot-value ?Feld __data))
				(bind ?Spalte (nth$ 1 ?FeldSlot))
				(bind ?Zeile (nth$ 2 ?FeldSlot))


				(printout t "Moeglichkeit (zum diagonalen " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)

			) ;; while
		) ;; if		
		
	
		(printout t "***** Funktion fertig! *****" crlf)
		(printout t " " crlf)
			
						
	) ;; if
	) ;; deffunction


(deffunction PruefenMehrMoeglichTemp (?Farbe ?A)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		(printout t " " crlf)
		(printout t "***** MASTER-ANFRAGE NACH MOEGLICHEN ZUEGEN (Ja/Nein) ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichMasterVar ?Farbe ?A) 0) then
			(return 1)
		else
			(return 0)
		) ;; if
	) ;; if
	) ;; deffunction
			
			



(deffunction PruefenMehrMoeglichMaster (?Farbe ?A)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		;;(printout t " " crlf)
		;;(printout t "***** MASTER-ANFRAGE NACH MOEGLICHEN ZUEGEN ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results MehrMoeglichMasterVar ?Farbe ?A) 0) then
			;;(printout t "Anzahl vertikaler Moeglichkeiten ist " (count-query-results MehrMoeglichMasterVar ?Farbe ?A) crlf)
			(bind ?treffer (run-query MehrMoeglichMasterVar ?Farbe ?A))
			;;(while (?treffer hasNext)
			;;	(bind ?token (call ?treffer next))
			;;	(bind ?Feld (call ?token fact 2))
			;;	(bind ?Zusammen (call ?token fact 1))
			;;	(bind ?FeldSlot (fact-slot-value ?Feld __data))
			;;	(bind ?ZusammenSlot (fact-slot-value ?Zusammen __data))
			;;	(bind ?Spalte (nth$ 1 ?FeldSlot))
			;;	(bind ?Zeile (nth$ 2 ?FeldSlot))
			;,	(bind ?Anzahl (nth$ 1 ?ZusammenSlot))
			;;	
			;;	(printout t "Moeglichkeit zum " (+ ?Anzahl 1) "-er) bei (" ?Spalte "," ?Zeile ")" crlf)
			;;	
			;;) ;; while
			
			;;(printout t "***** Funktion fertig! *****" crlf)
			;;(printout t " " crlf)
			(return ?treffer)
		
		) ;; if
			
		
			
						
	) ;; if
	) ;; deffunction
	

(deffunction PruefenLueckeTemp (?Farbe)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		;;(printout t " " crlf)
		;;(printout t "***** MASTER-ANFRAGE LUECKE (Ja/Nein) ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results LueckeMaster ?Farbe) 0) then
			(return 1)
		else
			(return 0)
		) ;; if
	) ;; if
	) ;; deffunction


(deffunction PruefenLueckeMaster (?Farbe)
	(if (or (= ?Farbe 2) (= ?Farbe 1)) then
	
		;;(printout t " " crlf)
		;;(printout t "***** MASTER-ANFRAGE NACH MOEGLICHEN ZUEGEN DURCH LUECKEN ******" crlf)
		
		;; ABFRAGE vertikaler Mglichkeiten
		(if (> (count-query-results LueckeMaster ?Farbe) 0) then
			(printout t "Anzahl von Luecken ist " (count-query-results LueckeMaster ?Farbe) crlf)
			(bind ?treffer (run-query LueckeMaster ?Farbe))
			
		) ;; if
			
		;;(printout t "***** Funktion LUECKEN-ANFRAGE fertig! *****" crlf)
		;;(printout t " " crlf)
		(return ?treffer)
			
						
	) ;; if
	) ;; deffunction



(deffunction Vierer ()
	;;(printout t "Pruefe auf VIERER in JESS ..." crlf)
	(if (> (count-query-results Vierer) 0) then
		;;(printout t "...true" crlf)
		(bind ?it (run-query Vierer))
		(while (?it hasNext)
			(bind ?token (call ?it next))
			(bind ?id (call ?token fact 1))
			(bind ?slot (fact-slot-value ?id __data))
		) ;;while

		(bind ?Farbe (nth$ 7 ?slot))
		
		(return ?Farbe)	
	
	else
		;;(printout t "...false" crlf)
		(return 0)
	) ;; if
	) ;; deffunction




;; ===============================
;; REGELN
;; ===============================

(defrule viererHorizontal
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Ya ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (+ ?Xa 2)) ?Ya ?Fa))
	(unique (Feld ?Xd&:(= ?Xd (+ ?Xa 3)) ?Ya ?Fa))
	=>
	(assert (Zusammen 4 h ?Xa ?Ya ?Xd ?Ya ?Fa))
	(printout t "Regel viererHorizontal angewendet!" crlf) )
	
(defrule viererVertikal
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xa ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xa ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	(unique (Feld ?Xa ?Yd&:(= ?Yd (+ ?Ya 3)) ?Fa))
	=>
	(assert (Zusammen 4 v ?Xa ?Ya ?Xa ?Yd ?Fa))
	(printout t "Regel viererVertikal angewendet!" crlf) )
	
(defrule viererDiagonal1
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (+ ?Xa 2)) ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	(unique (Feld ?Xd&:(= ?Xd (+ ?Xa 3)) ?Yd&:(= ?Yd (+ ?Ya 3)) ?Fa))
	=>
	(assert (Zusammen 4 d1 ?Xa ?Ya ?Xd ?Yd ?Fa))
	(printout t "Regel viererDiagonal1 angewendet!" crlf) )

	
(defrule viererDiagonal2
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (- ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (- ?Xa 2)) ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	(unique (Feld ?Xd&:(= ?Xd (- ?Xa 3)) ?Yd&:(= ?Yd (+ ?Ya 3)) ?Fa))
	=>
	(assert (Zusammen 4 d2 ?Xa ?Ya ?Xd ?Yd ?Fa))
	(printout t "Regel viererDiagonal2 angewendet!" crlf) )
	
;; -------------------------

(defrule dreierHorizontal
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Ya ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (+ ?Xa 2)) ?Ya ?Fa))
	=>
	(assert (Zusammen 3 h ?Xa ?Ya ?Xc ?Ya ?Fa))
	(printout t "Regel dreierHorizontal angewendet!" crlf) )
	
(defrule dreierVertikal
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xa ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xa ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	=>
	(assert (Zusammen 3 v ?Xa ?Ya ?Xa ?Yc ?Fa))
	(printout t "Regel dreierVertikal angewendet!" crlf) )
	
(defrule dreierDiagonal1
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (+ ?Xa 2)) ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	=>
	(assert (Zusammen 3 d1 ?Xa ?Ya ?Xc ?Yc ?Fa))
	(printout t "Regel dreierDiagonal1 angewendet!" crlf) )

	
(defrule dreierDiagonal2
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (- ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	(unique (Feld ?Xc&:(= ?Xc (- ?Xa 2)) ?Yc&:(= ?Yc (+ ?Ya 2)) ?Fa))
	=>
	(assert (Zusammen 3 d2 ?Xa ?Ya ?Xc ?Yc ?Fa))
	(printout t "Regel dreierDiagonal2 angewendet!" crlf) )
	
;; -------------------------	
	

;; -------------------------

(defrule zweierHorizontal
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Ya ?Fa))
	=>
	(assert (Zusammen 2 h ?Xa ?Ya ?Xb ?Ya ?Fa))
	(printout t "Regel zweierHorizontal angewendet!" crlf) )
	
(defrule zweierVertikal
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xa ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	;; (test (testrule))
	=>
	(assert (Zusammen 2 v ?Xa ?Ya ?Xa ?Yb ?Fa))
	(printout t "Regel zweierVertikal angewendet!" crlf) )
	
(defrule zweierDiagonal1
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (+ ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	=>
	(assert (Zusammen 2 d1 ?Xa ?Ya ?Xb ?Yb ?Fa))
	(printout t "Regel zweierDiagonal1 angewendet!" crlf) )

	
(defrule zweierDiagonal2
	;;?fact <- 
	(Feld ?Xa ?Ya ?Fa&~0)
	(unique (Feld ?Xb&:(= ?Xb (- ?Xa 1)) ?Yb&:(= ?Yb (+ ?Ya 1)) ?Fa))
	=>
	(assert (Zusammen 2 d2 ?Xa ?Ya ?Xb ?Yb ?Fa))
	(printout t "Regel zweierDiagonal2 angewendet!" crlf) )
	
;; ------------------------	



;; ===============================
;; TEST-AUFSTELLUNG
;; ===============================

;; (facts)
;;(SteinHinzuSpalte 3 1)
;;(SteinHinzuSpalte 4 1)
;;(SteinHinzuSpalte 5 1)
;;(SteinHinzuSpalte 4 2)
;;(SteinHinzuSpalte 5 2)
;;(SteinHinzuSpalte 5 1)
;;(PruefenMehrMoeglich 2)
;;(SteinHinzuSpalte 4 2)
;;(SteinHinzuSpalte 3 2)
;;(SteinHinzuSpalte 5 2)
;;(PruefenMehrMoeglich 2)


