package wuerfeln;

import gamehost.AbsGameHost;
import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;

class EvaluateMove extends OneShotBehaviour {
  private wuerfeln.GameHost gameHost;
  private int exitCode;

  public EvaluateMove(wuerfeln.GameHost a) {
    super(a);
    gameHost = a;
  }

  public void action() {
    gameHost.println(gameHost.getCurrentPlayer().getLocalName() + ": Bitte ziehen!");
    sendYourTurn();
    receiveTurn();
    // ***** Zug ausfhren *****
    // Zufallszahl fr Wrfeln erzeugen
    int zufallszahl = (int)Math.round(Math.ceil(6.0 * Math.random()));
    gameHost.print(gameHost.getCurrentPlayer().getLocalName() + " will wrfeln.");
    gameHost.println("Fr " + gameHost.getCurrentPlayer().getLocalName() + " gewrfelt: " + zufallszahl);
    gameHost.addScore(zufallszahl, gameHost.getPlayerZaehler());
    // ***** Spiel zu Ende? *****
    if (gameHost.genugRunden()) {
      gameHost.determineWinner();
      exitCode = AbsGameHost.GAME_OVER;
    } else {
      exitCode = AbsGameHost.GAME_NOT_OVER;
      gameHost.incrementPlayerZaehler();
    }
  }

  private ACLMessage receiveTurn() {
    // ***** Zug vom Spieler empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    MessageTemplate m2 = MessageTemplate.MatchContent("MakeMove");
    MessageTemplate m3 = MessageTemplate.MatchSender(gameHost.getCurrentPlayer());
    MessageTemplate m4 = MessageTemplate.and(m1, m2);
    MessageTemplate m5 = MessageTemplate.and(m4, m3);
    // blockingReceive: es wird beliebig lang auf eine spezifische Nachricht gewartet
    return myAgent.blockingReceive(m5);
  }

  private void sendYourTurn() {
    // ***** Zugaufforderung an nchsten Spieler senden *****
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(gameHost.getCurrentPlayer());
    msg.setContent("YourTurn");
    // msg.setLanguage("welcheLanguage");
    // msg.setOntology("welcheOntology");
    myAgent.send(msg);
  }

  public int onEnd() {
    return exitCode;
  }
}
