package wuerfeln;

import gamehost.AbsGameHost;
import gamehost.GameHostWindow;
import jade.core.AID;
import strategy.Strategy;
import strategy.onto.StrategyDescription;

public class GameHost extends AbsGameHost {
  private int runde = 1; // am Anfang Runde 1
  private int maxRunde = 5;
  private int[] score;
  private GameHostWindow textWin;

  /** Creates new GameHost */
  public GameHost() {
    super();
    maxPlayers = 2;
    maxGames = 10000;
    score = new int[maxPlayers];
    game = "Wuerfeln";
    fee = 5;
    prize = 8;
    // ***** Fr jede Strategie eine Beschreibung erstellen *****
    StrategyDescription sd = new StrategyDescription();
    sd.setGame(game);
    sd.setName("Einfach");
    sd.setRisk(0);
    makeMoveBehaviour = new Strategy[1];
    makeMoveBehaviour[0] = new Strategy(sd, new SendMove(null));
    evaluateMoveBehaviour = new EvaluateMove(this);
    textWin = new GameHostWindow(game);
  }

  public void incrementPlayerZaehler() {
    super.incrementPlayerZaehler();
    if (playerZaehler == 0) runde++;
  }

  public void determineWinner() {
    printScores();
    AID wnr = (AID)players.elementAt(getHighestScoreIndex());
    println(wnr.getLocalName() + " hat gewonnen.");
    setWinner(wnr);
  }

  public void resetGame() {
    super.resetGame();
    runde = 1;
    for (int i = 0; i < maxPlayers; i++) score[i] = 0;
  }

  public boolean genugRunden() {
    return ((runde >= maxRunde) && (playerZaehler == (maxPlayers - 1)));
  }

  public void addScore(int amount, int playerNo) { score[playerNo] += amount; }

  public void printScores() {
    println();
    println("*** Spielstand ***");
    for (int i = 0; i < maxPlayers; i++)
      println(((AID)players.elementAt(i)).getLocalName() + ": " + score[i]);
    println();
  }

  private int getHighestScoreIndex() {
    int max = -1;
    int index = -1;
    for (int i = 0; i < maxPlayers; i++)
      if (max < score[i]) {
        max = score[i];
        index = i;
      }
    return index;
  }

  public void print(String text) {
    textWin.print(text);
  }

  public void println(String text) {
    textWin.println(text);
  }

  public void println() {
    textWin.println();
  }
}
