package wuerfeln;

import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import player.CheckCredits;
import player.Player;

class SendMove extends OneShotBehaviour {
  private final int MY_TURN = 1;
  private final int WON = 2;
  private final int LOST = 3;
  private final int UNKNOWN = 4;

  public SendMove(Player a) { super(a); }

  public void action() {
    int msg = empfangen();
    // wenn an der Reihe, Zug ausfhren
    while (msg == MY_TURN) {
      senden();
      msg = empfangen();
    }
    if (msg == WON) ((Player)myAgent).sendWon(); else if (msg == LOST) ((Player)myAgent).sendLost();
    myAgent.addBehaviour(new CheckCredits(myAgent));
  }

  private int empfangen() {
    // ***** Nachricht vom GameHost empfangen *****
    // MessageTemplate zusammenstellen
    MessageTemplate m1 = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
    // MessageTemplate m2 = MessageTemplate.MatchContent("YourTurn");
    MessageTemplate m3 = MessageTemplate.MatchSender(((Player)myAgent).getHost());
    MessageTemplate m5 = MessageTemplate.and(m1, m3);
    // receive: Warten auf Nachricht von GameHost
    ACLMessage msg = myAgent.blockingReceive(m5);
    // ***** Nachricht auswerten *****
    // hier einfach, da einfaches Wrfelspiel
    if (msg.getContent().equalsIgnoreCase("YourTurn")) return MY_TURN; else if (msg.getContent().equalsIgnoreCase("Won"))
      return WON; else if (msg.getContent().equalsIgnoreCase("Lost")) return LOST; else
      return UNKNOWN;
  }

  private void senden() {
    // ***** Zug bestimmen/errechnen *****
    // enfllt hier, da einfaches Wrfelspiel
    // ***** Zug an GameHost senden *****
    // neue ACLMessage vom Typ inform generieren und mit Attributen fllen
    ACLMessage msg = new ACLMessage(ACLMessage.INFORM);
    msg.setSender(myAgent.getAID());
    msg.addReceiver(((Player)myAgent).getHost());
    msg.setContent("MakeMove");
    // msg.setLanguage("welcheLanguage");
    // msg.setOntology("welcheOntology");
    // Nachricht senden
    myAgent.send(msg);
    //System.out.println(myAgent.getLocalName() + ": Gezogen.");
  }
}
